# coding: utf-8

"""
    Phrase TMS API

    Welcome to Phrase's TMS API documentation.    Please visit our [help center](https://support.phrase.com/hc/en-us/sections/5709662083612) for more information about the APIs.    If you have any questions, please contact [Support](https://support.phrase.com/hc/requests/new).    Please, include the `User-Agent` header with the name of your application or project. It might be a good idea to include some sort of contact information as well, so that we can get in touch if necessary. Examples of excellent `User-Agent` headers:  > User-Agent: Example mobile app (example@phrase.com) <br/> User-Agent: ACME Inc Java 1.8 Client (http://acmeinc.com/contact)  # noqa: E501

    The version of the OpenAPI document: Latest
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, conlist, constr
from phrasetms_client.models.id_reference import IdReference
from phrasetms_client.models.provider_reference import ProviderReference
from phrasetms_client.models.uid_reference import UidReference

class BulkEditAnalyseV2Dto(BaseModel):
    """
    BulkEditAnalyseV2Dto
    """
    analyses: conlist(IdReference, max_items=100, min_items=1) = Field(...)
    name: Optional[constr(strict=True, max_length=255, min_length=0)] = None
    provider: Optional[ProviderReference] = None
    net_rate_scheme: Optional[UidReference] = Field(None, alias="netRateScheme")
    __properties = ["analyses", "name", "provider", "netRateScheme"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> BulkEditAnalyseV2Dto:
        """Create an instance of BulkEditAnalyseV2Dto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in analyses (list)
        _items = []
        if self.analyses:
            for _item in self.analyses:
                if _item:
                    _items.append(_item.to_dict())
            _dict['analyses'] = _items
        # override the default output from pydantic by calling `to_dict()` of provider
        if self.provider:
            _dict['provider'] = self.provider.to_dict()
        # override the default output from pydantic by calling `to_dict()` of net_rate_scheme
        if self.net_rate_scheme:
            _dict['netRateScheme'] = self.net_rate_scheme.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> BulkEditAnalyseV2Dto:
        """Create an instance of BulkEditAnalyseV2Dto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return BulkEditAnalyseV2Dto.parse_obj(obj)

        _obj = BulkEditAnalyseV2Dto.parse_obj({
            "analyses": [IdReference.from_dict(_item) for _item in obj.get("analyses")] if obj.get("analyses") is not None else None,
            "name": obj.get("name"),
            "provider": ProviderReference.from_dict(obj.get("provider")) if obj.get("provider") is not None else None,
            "net_rate_scheme": UidReference.from_dict(obj.get("netRateScheme")) if obj.get("netRateScheme") is not None else None
        })
        return _obj

