# coding: utf-8

"""
    Phrase TMS API

    Welcome to Phrase's TMS API documentation.    Please visit our [help center](https://support.phrase.com/hc/en-us/sections/5709662083612) for more information about the APIs.    If you have any questions, please contact [Support](https://support.phrase.com/hc/requests/new).    Please, include the `User-Agent` header with the name of your application or project. It might be a good idea to include some sort of contact information as well, so that we can get in touch if necessary. Examples of excellent `User-Agent` headers:  > User-Agent: Example mobile app (example@phrase.com) <br/> User-Agent: ACME Inc Java 1.8 Client (http://acmeinc.com/contact)  # noqa: E501

    The version of the OpenAPI document: Latest
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, validator

class MultilingualXmlSettingsDto(BaseModel):
    """
    MultilingualXmlSettingsDto
    """
    translatable_elements_x_path: Optional[StrictStr] = Field(None, alias="translatableElementsXPath")
    source_elements_x_path: Optional[StrictStr] = Field(None, alias="sourceElementsXPath")
    target_elements_x_paths: Optional[Dict[str, StrictStr]] = Field(None, alias="targetElementsXPaths", description="'Format: \"language\":\"xpath\";             example = '{\"en\": \"tuv[@lang='en']/seg\", \"sk\": \"tuv[@lang='sk']/seg\"}")
    inline_elements_non_translatable_x_path: Optional[StrictStr] = Field(None, alias="inlineElementsNonTranslatableXPath")
    tag_regexp: Optional[StrictStr] = Field(None, alias="tagRegexp")
    segmentation: Optional[StrictBool] = Field(None, description="Default: `true`")
    html_sub_filter: Optional[StrictBool] = Field(None, alias="htmlSubFilter", description="Default: `false`")
    context_key_x_path: Optional[StrictStr] = Field(None, alias="contextKeyXPath")
    context_note_x_path: Optional[StrictStr] = Field(None, alias="contextNoteXPath")
    max_len_x_path: Optional[StrictStr] = Field(None, alias="maxLenXPath")
    preserve_whitespace: Optional[StrictBool] = Field(None, alias="preserveWhitespace", description="Default: `false`")
    preserve_char_entities: Optional[StrictStr] = Field(None, alias="preserveCharEntities")
    xsl_url: Optional[StrictStr] = Field(None, alias="xslUrl")
    xsl_file: Optional[StrictStr] = Field(None, alias="xslFile", description="UID of uploaded XSL file, overrides xslUrl")
    non_empty_segment_action: Optional[StrictStr] = Field(None, alias="nonEmptySegmentAction")
    save_confirmed_segments_to_tm: Optional[StrictBool] = Field(None, alias="saveConfirmedSegmentsToTm")
    icu_sub_filter: Optional[StrictBool] = Field(None, alias="icuSubFilter", description="Default: `false`")
    __properties = ["translatableElementsXPath", "sourceElementsXPath", "targetElementsXPaths", "inlineElementsNonTranslatableXPath", "tagRegexp", "segmentation", "htmlSubFilter", "contextKeyXPath", "contextNoteXPath", "maxLenXPath", "preserveWhitespace", "preserveCharEntities", "xslUrl", "xslFile", "nonEmptySegmentAction", "saveConfirmedSegmentsToTm", "icuSubFilter"]

    @validator('non_empty_segment_action')
    def non_empty_segment_action_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in ('NONE', 'CONFIRM', 'LOCK', 'CONFIRM_LOCK'):
            raise ValueError("must be one of enum values ('NONE', 'CONFIRM', 'LOCK', 'CONFIRM_LOCK')")
        return value

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> MultilingualXmlSettingsDto:
        """Create an instance of MultilingualXmlSettingsDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> MultilingualXmlSettingsDto:
        """Create an instance of MultilingualXmlSettingsDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return MultilingualXmlSettingsDto.parse_obj(obj)

        _obj = MultilingualXmlSettingsDto.parse_obj({
            "translatable_elements_x_path": obj.get("translatableElementsXPath"),
            "source_elements_x_path": obj.get("sourceElementsXPath"),
            "target_elements_x_paths": obj.get("targetElementsXPaths"),
            "inline_elements_non_translatable_x_path": obj.get("inlineElementsNonTranslatableXPath"),
            "tag_regexp": obj.get("tagRegexp"),
            "segmentation": obj.get("segmentation"),
            "html_sub_filter": obj.get("htmlSubFilter"),
            "context_key_x_path": obj.get("contextKeyXPath"),
            "context_note_x_path": obj.get("contextNoteXPath"),
            "max_len_x_path": obj.get("maxLenXPath"),
            "preserve_whitespace": obj.get("preserveWhitespace"),
            "preserve_char_entities": obj.get("preserveCharEntities"),
            "xsl_url": obj.get("xslUrl"),
            "xsl_file": obj.get("xslFile"),
            "non_empty_segment_action": obj.get("nonEmptySegmentAction"),
            "save_confirmed_segments_to_tm": obj.get("saveConfirmedSegmentsToTm"),
            "icu_sub_filter": obj.get("icuSubFilter")
        })
        return _obj

